import axios from 'axios';
import { API_URL, APP_VERSION } from '../constants';
import { Platform } from 'react-native';
import { showBanner } from './bannerUtils';

export const request = axios.create({
  baseURL: API_URL,
  timeout: 10000,
});

request.interceptors.request.use(config => {
  config.headers['App-Version'] = APP_VERSION;
  config.headers['Platform'] = Platform.OS;
  return config;
}, error => {
  return Promise.reject(error);
});

request.interceptors.response.use(response => {
  return response;
}, error => {
  if (error.code === 'ECONNABORTED') {
    error.isTimeout = true;
    showBanner('Slow internet connection!');
  }
  return Promise.reject(error);
});
